﻿angular.module('treeViewAppModule')
    .controller('treeViewController', [
        "$scope", "treeViewService", function ($scope, treeViewService)
        {
            var books = [
                        { id: 1, name: "Select All"},
                        { id: 2, name: "Fiction Book Lists", hasChild: true, isExpanded: true, isChecked: true },
                        { id: 3, parentId: 2, name: "To Kill a Mockingbird " },
                        { id: 4, parentId: 2, name: "Pride and Prejudice " },
                        { id: 5, parentId: 2, name: "Harry Potter and the Sorcerer's Stone" },
                        { id: 6, parentId: 2, name: "The Hobbit " },
                        { id: 7, name: "Mystery Book Lists", hasChild: true, isExpanded: true },
                        { id: 8, parentId: 7, name: "And Then There Were None " },
                        { id: 9, parentId: 7, name: "Angels & Demons" },
                        { id: 10, parentId: 7, name: "In Cold Blood " },
                        { id: 11, parentId: 7, name: "The Name of the Rose " },
                        { id: 12, name: "Horror Novels", hasChild: true },
                        { id: 13, parentId: 12, name: "The Shining (The Shining, #1) " },
                        { id: 14, parentId: 12, name: "The Haunting of Hill House " },
                        { id: 15, parentId: 12, name: "The Silence of the Lambs (Hannibal Lecter, #2) " },
                        { id: 16, parentId: 12, name: "The Fog " },
                        { id: 17, name: "Novel Lists", hasChild: true },
                        { id: 18, parentId: 17, name: "Shadow Hills (Shadow Hills, #1) " },
                        { id: 19, parentId: 17, name: "After Forever Ends " },
                        { id: 20, parentId: 17, name: "Angel Star" },
                        { id: 21, parentId: 17, name: "Falling From Grace" }];

            $scope.instanceTreeViewList1 = books;

            $scope.instanceTreeViewList2 = treeViewService.treeViewList;

            function loadInstances()
            {
                treeViewService.getTreeViewList()
                    .then(function ()
                    {
                        $scope.isSuccess = true;
                    },
                    function ()
                    {
                        $scope.isSuccess = false;
                    });
            }

            loadInstances();

            //$scope.$watch('instanceTreeViewList1', function (newVal) {
            //    alert("isChecked is " + newVal);
            //}, true);

            $scope.instanceItemChecked1 = function (args) {
                if (args.id == "1") {
                    angular.forEach($scope.instanceTreeViewList1, function (item) {
                        if (item.id != "1") {
                            item.isChecked = true;
                        }
                    });
                    $scope.$apply();
                }
                else {

                }
            };

            $scope.instanceItemUnchecked1 = function (args) {
                if (args.id == "1") {
                    angular.forEach($scope.instanceTreeViewList1, function (item) {
                        if (item.id != "1") {
                            item.isChecked = false;
                        }
                    });
                    $scope.$apply();
                }
                else {

                }
            };

            $scope.instanceItemChecked2 = function (args) {
                if (args.id == "1") {
                    angular.forEach($scope.instanceTreeViewList2, function (item) {
                        if (item.id != "1") {
                            item.isChecked = true;
                        }
                    });
                    $scope.$apply();
                }
                else {

                }
            };

            $scope.instanceItemUnchecked2 = function (args) {
                if (args.id == "1") {
                    angular.forEach($scope.instanceTreeViewList2, function (item) {
                        if (item.id != "1") {
                            item.isChecked = false;
                        }
                    });
                    $scope.$apply();
                }
                else {

                }
            };

        }
    ]);
