﻿using System;
using System.Collections.Generic;
using System.Web.Http;
using TreeviewAngular.Models;

namespace TreeviewAngular.ApiControllers
{
    public class TreeViewApiController : ApiController
    {
        // GET api/<controller>
        [Route("api/treeView/")]
        public IEnumerable<TreeViewViewModel> GetInstances()
        {
            var instanceList = new List<TreeViewViewModel>();

            var selectAll = new TreeViewViewModel { Id = 1, Name = "Select All" };
            var instance1 = new TreeViewViewModel { Id = 2, Name = "Fiction Book Lists", HasChild = true, IsExpanded = true };
            var child1instance1 = new TreeViewViewModel { Id = 3, ParentId = instance1.Id, Name = "To Kill a Mockingbird" };
            var child1instance2 = new TreeViewViewModel { Id = 4, ParentId = instance1.Id, Name = "Pride and Prejudice" };
            var child1instance3 = new TreeViewViewModel { Id = 5, ParentId = instance1.Id, Name = "Harry Potter and the Sorcerer's Stone" };
            var child1instance4 = new TreeViewViewModel { Id = 6, ParentId = instance1.Id, Name = "The Hobbit4" };
            var instance2 = new TreeViewViewModel { Id = 7, Name = "Mystery Book Lists", HasChild = true, IsExpanded = true };
            var child2instance1 = new TreeViewViewModel { Id = 8, ParentId = instance2.Id, Name = "And Then There Were None" };
            var child2instance2 = new TreeViewViewModel { Id = 9, ParentId = instance2.Id, Name = "Angels & Demons" };
            var child2instance3 = new TreeViewViewModel { Id = 10, ParentId = instance2.Id, Name = "In Cold Blood" };
            var child2instance4 = new TreeViewViewModel { Id = 11, ParentId = instance2.Id, Name = "The Name of the Rose" };
            var instance3 = new TreeViewViewModel { Id = 12, Name = "Horror Novels", HasChild = true, IsChecked = true };
            var child3instance1 = new TreeViewViewModel { Id = 13, ParentId = instance3.Id, Name = "The Shining (The Shining, #1)" };
            var child3instance2 = new TreeViewViewModel { Id = 14, ParentId = instance3.Id, Name = "The Haunting of Hill House" };
            var child3instance3 = new TreeViewViewModel { Id = 15, ParentId = instance3.Id, Name = "The Silence of the Lambs (Hannibal Lecter, #2)" };
            var child3instance4 = new TreeViewViewModel { Id = 16, ParentId = instance3.Id, Name = "The Fog" };
            var instance4 = new TreeViewViewModel { Id = 17, Name = "Novel Lists", HasChild = true };
            var child4instance1 = new TreeViewViewModel { Id = 18, ParentId = instance4.Id, Name = "Shadow Hills (Shadow Hills, #1)" };
            var child4instance2 = new TreeViewViewModel { Id = 19, ParentId = instance4.Id, Name = "After Forever Ends" };
            var child4instance3 = new TreeViewViewModel { Id = 20, ParentId = instance4.Id, Name = "Angel Star" };
            var child4instance4 = new TreeViewViewModel { Id = 21, ParentId = instance4.Id, Name = "Falling From Grace" };
            instanceList.Add(selectAll);
            instanceList.Add(instance1);
            instanceList.Add(instance2);
            instanceList.Add(instance3);
            instanceList.Add(instance4);
            instanceList.Add(child1instance1);
            instanceList.Add(child1instance2);
            instanceList.Add(child1instance3);
            instanceList.Add(child1instance4);

            instanceList.Add(child2instance1);
            instanceList.Add(child2instance2);
            instanceList.Add(child2instance3);
            instanceList.Add(child2instance4);

            instanceList.Add(child3instance1);
            instanceList.Add(child3instance2);
            instanceList.Add(child3instance3);
            instanceList.Add(child3instance4);

            instanceList.Add(child4instance1);
            instanceList.Add(child4instance2);
            instanceList.Add(child4instance3);
            instanceList.Add(child4instance4);

            var array = instanceList.ToArray();
            return array;
        }
    }
}