﻿angular.module('treeViewAppModule')
    .factory('treeViewService', ["$http", "$q", function ($http, $q)
    {
        var _treeViewList = [];

        var _getTreeViewList = function ()
        {
            var deferred = $q.defer();
            $http.get("/api/treeView/")
                .then(function (result)
                {
                    angular.copy(result.data, _treeViewList);
                    deferred.resolve();
                },
                    function ()
                    {
                        deferred.reject();
                    });

            return deferred.promise;
        };

        return {
            treeViewList: _treeViewList,
            getTreeViewList: _getTreeViewList
        };
    }]);